require 'socket'

class CarbonClient
    def initialize(hstr)
        @host, @port = hstr.split(":")
        @port = 2003 unless @port
        @port = @port.to_i
    end
    
    def getSocket
        STDOUT.puts @host
        @socket = TCPSocket.new(@host.to_s, @port) unless @socket && !@socket.closed?
        return @socket
    end

    def closeSocket
        @socket.close if @socket
        @socket = nil
    end

    def sendMetric(key, value, time = Time.now)
        begin
            getSocket.puts("#{key} #{value.to_f} #{time.to_i}")
        rescue Errno::EPIPE, Errno::EHOSTUNREACH, Errno::EHOSTDOWN
            @socket = nil
            return nil
        end
        closeSocket if @socket
    end
    
end

module Notify; end

class Notify::Graphite < BasicObject
    VERSION = "0.0.2"
    
    def initialize(host, port=2003, basename=nil)
        @basename    = ["events", basename].compact.join('.')
        @client      = ::CarbonClient.new(host+":"+port.to_s)
    end

    def send_event(event_name)
        @client.sendMetric(@basename+"."+event_name, 1)
        #TODO: we should also send a "normal" graphite event to the json api.
    end    
    
end
